
/* Calculadora de notacion infija.
   Basado en la calculadora polaca inversa de doble presicion,
   que es el Ejemplo No 1 del manual de Bison Version 1.27 en espa~nol*/

%{ 
#define YYSTYPE double  /* definicion del tipo de datos de bison a double */
#include <math.h> /* incluyendo las librerias necesarias para las reglas*/
                    /* y las funciones definidas por el usuario*/
#include <stdio.h>

double vars[26];
double set_value(char var, double value);
double  get_value(char var);
%} 
%token NUM /* declaracion de un token Bison, esto es un terminal de una GLC */

%% /* A continuacion las reglas gramaticales y las acciones */ 
input:    /* vacioo */ 
        | input line 
; 
line:     '\n'      { printf ("> "); }
        | '(' exp ')' '\n'  { printf ("\t%.10g\n> ", $2); }
          /* imprime el resultado del calculo, por eso no incluye un $$ */
        | error '\n' {yyerrok; printf ("> ");}
; 
exp:      NUM               { $$ = $1; } 
        | '(' exp ')'       { $$ = $2; }
        | '+' expS          { $$ = $2}
        | '-' exp exp       { $$ = $2 - $3; } 
        | '*' expM          { $$ = $2; }
        | '/' exp exp       { $$ = $2 / $3; } 
        | '?' exp exp exp   { $$ = ($2 != 0)? $3 : $4; }
        | 'N' exp           { $$ = -$2; } /* Menos unario   */ 
        | '^' exp exp       { $$ = pow ($2, $3); } /* Exponenciación */ 
        | var               { $$ = get_value($1); }
        | '=' var exp       { $$ = set_value($2, $3); }
        | '#' var exp       { $$ = set_value($2, get_value($2) + $3); }
        | '@' var exp       { $$ = set_value($2, get_value($2) - $3); }
        | 'S' var exp exp exp { double suma = 0; int i;
                                for (i = $3; i <= $4; i++) suma += $5;
                                $$ = suma;
                              }
;
expS:     exp              { $$ = $1; }
        | expS exp         { $$ = $1 + $2; }
;
expM:     exp              { $$ = $1; }
        | expM exp         { $$ = $1 * $2; }
;
var       : 'a'                           { $$ = 'a'; }
          | 'b'                           { $$ = 'b'; }
          | 'c'                           { $$ = 'c'; }
          | 'd'                           { $$ = 'd'; }
          | 'e'                           { $$ = 'e'; }
          | 'f'                           { $$ = 'f'; }
          | 'g'                           { $$ = 'g'; }
          | 'h'                           { $$ = 'h'; }
          | 'i'                           { $$ = 'i'; }
          | 'j'                           { $$ = 'j'; }
          | 'k'                           { $$ = 'k'; }
          | 'l'                           { $$ = 'l'; }
          | 'm'                           { $$ = 'm'; }
          | 'n'                           { $$ = 'n'; }
          | 'o'                           { $$ = 'o'; }
          | 'p'                           { $$ = 'p'; }
          | 'q'                           { $$ = 'q'; }
          | 'r'                           { $$ = 'r'; }
          | 's'                           { $$ = 's'; }
          | 't'                           { $$ = 't'; }
          | 'u'                           { $$ = 'u'; }
          | 'v'                           { $$ = 'v'; }
          | 'w'                           { $$ = 'w'; }
          | 'x'                           { $$ = 'x'; }
          | 'y'                           { $$ = 'y'; }
          | 'z'                           { $$ = 'z'; }
;
%% /* a continuacion las funciones auxiliares */

/* El analizador lexico devuelve un número n punto
   flotante (double) en la pila y el token NUM, o el 
   caracter ASCII leido si no es un número.  Ignora 
   todos los espacios en blanco y tabuladores, 
   devuelve 0 como EOF.

   El valor de retorno de yylex es el codigo numerico del
   tipo de token. El valor semantico del token se guarda
   en la variable yylval, ver procesamiento de numeros */

#include <ctype.h> /* estas librerias son usadas por las funciones
   yylex, yyerror y main, y las otras funciones definidias por el usuario */

yylex () { 
  int c; 
  /* ignora los espacios en blanco o tabuladores */ 
  while ((c = getchar ()) == ' ' || c == '\t')  
    ; 
  /* procesa numeros */
  if (c == '.' || isdigit (c)) 
    { 
      ungetc (c, stdin); 
      scanf ("%lf", &yylval); 
      return NUM; 
    } 
  /* devuelve fin-de-fichero  */ 
  if (c == EOF)                            
    return 0; 
  /* devuelve caracteres sencillos */ 
  return c;                                
}


/* rutina de manejo de errores */

yyerror (char *s) {  /* Llamada por yyparse ante un error */ 
  printf ("%s\n", s); 
}

/* rutina de control */
main() {
  int i;
  for (i = 0; i < 26; i++) {vars[i] = 0;}
  printf("> ");
  yyparse();
}

double set_value(char var, double value) {
  return (vars[var - 'a'] = value);
}

double get_value(char var) {
  return(vars[var - 'a']);
}
